Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2232)
@@ -2139,42 +2455,71 @@
           CASE ( 'usm_surfz' )
 !--           array of lw radiation falling to local surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == ids )  THEN
-                      IF ( surfl(id,isurf) == iroof )  THEN
-                          temp_pf(0,surfl(iy,isurf),surfl(ix,isurf)) =             &
-                                  max(temp_pf(0,surfl(iy,isurf),surfl(ix,isurf)),  &
-                                      REAL(surfl(iz,isurf),wp))
-                      ELSE
-                          temp_pf(0,surfl(iy,isurf),surfl(ix,isurf)) =             &
-                                  max(temp_pf(0,surfl(iy,isurf),surfl(ix,isurf)),  &
-                                      REAL(surfl(iz,isurf),wp)+1.0_wp)
-                      ENDIF
-                  ENDIF
+              DO  m = 1, surf_usm_h%ns
+                 i = surf_usm_h%i(m)
+                 j = surf_usm_h%j(m)
+                 k = surf_usm_h%k(m)
+                 temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, kind=wp) )
+              ENDDO
+              DO  l = 0, 3
+                 DO  m = 1, surf_usm_v(l)%ns
+                    i = surf_usm_v(l)%i(m)
+                    j = surf_usm_v(l)%j(m)
+                    k = surf_usm_v(l)%k(m)
+                    temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, kind=wp) + 1.0_wp )
+                 ENDDO
               ENDDO
 
           CASE ( 'usm_surfcat' )
 !--           surface category
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surface_types(isurf)
-                 ENDIF
+              DO  m = 1, surf_usm_h%ns
+                 i = surf_usm_h%i(m)
+                 j = surf_usm_h%j(m)
+                 k = surf_usm_h%k(m)
+                 temp_pf(k,j,i) = surf_usm_h%surface_types(m)
+              ENDDO
+              DO  l = 0, 3
+                 DO  m = 1, surf_usm_v(l)%ns
+                    i = surf_usm_v(l)%i(m)
+                    j = surf_usm_v(l)%j(m)
+                    k = surf_usm_v(l)%k(m)
+                    temp_pf(k,j,i) = surf_usm_v(l)%surface_types(m)
+                 ENDDO
               ENDDO
               
           CASE ( 'usm_surfalb' )
 !--           surface albedo
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = albedo_surf(isurf)
-                 ENDIF
+              DO  m = 1, surf_usm_h%ns
+                 i = surf_usm_h%i(m)
+                 j = surf_usm_h%j(m)
+                 k = surf_usm_h%k(m)
+                 temp_pf(k,j,i) = surf_usm_h%albedo_surf(m)
+              ENDDO
+              DO  l = 0, 3
+                 DO  m = 1, surf_usm_v(l)%ns
+                    i = surf_usm_v(l)%i(m)
+                    j = surf_usm_v(l)%j(m)
+                    k = surf_usm_v(l)%k(m)
+                    temp_pf(k,j,i) = surf_usm_v(l)%albedo_surf(m)
+                 ENDDO
               ENDDO
               
           CASE ( 'usm_surfemis' )
 !--           surface albedo
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = emiss_surf(isurf)
-                 ENDIF
+              DO  m = 1, surf_usm_h%ns
+                 i = surf_usm_h%i(m)
+                 j = surf_usm_h%j(m)
+                 k = surf_usm_h%k(m)
+                 temp_pf(k,j,i) = surf_usm_h%emiss_surf(m)
               ENDDO
-              
+              DO  l = 0, 3
+                 DO  m = 1, surf_usm_v(l)%ns
+                    i = surf_usm_v(l)%i(m)
+                    j = surf_usm_v(l)%j(m)
+                    k = surf_usm_v(l)%k(m)
+                    temp_pf(k,j,i) = surf_usm_v(l)%emiss_surf(m)
+                 ENDDO
+              ENDDO
+!
+!-- Not adjusted so far              
           CASE ( 'usm_svf', 'usm_dif' )
 !--           shape view factors or iradiance factors to selected surface
@@ -2197,13 +2542,35 @@
           CASE ( 'usm_rad_net' )
 !--           array of complete radiation balance
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                   IF ( av == 0 )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = rad_net_l(isurf)
-                   ELSE
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = rad_net_av(isurf)
-                   ENDIF
-                 ENDIF
-              ENDDO
+              IF ( av == 0 )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%rad_net_l(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%rad_net_l(m)
+                    ENDDO
+                 ENDDO
+              ELSE
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%rad_net_av(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%rad_net_av(m)
+                    ENDDO
+                 ENDDO
+              ENDIF
 
           CASE ( 'usm_rad_insw' )
@@ -2268,16 +2635,4 @@
               ENDDO
 
-          CASE ( 'usm_rad_inlwdif' )
-!--           array of sw radiation falling to surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                   IF ( av == 0 )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlwdif(isurf)
-                   ELSE
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlwdif_av(isurf)
-                   ENDIF
-                 ENDIF
-              ENDDO
-
           CASE ( 'usm_rad_inlwref' )
 !--           array of lw radiation falling to surface from reflections
@@ -2339,65 +2694,175 @@
                  ENDIF
               ENDDO
-
+ 
           CASE ( 'usm_rad_hf' )
 !--           array of heat flux from radiation for surfaces after all reflections
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                   IF ( av == 0 )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfhf(isurf)
-                   ELSE
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfhf_av(isurf)
-                   ENDIF
-                 ENDIF
-              ENDDO
-
+              IF ( av == 0 )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%surfhf(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%surfhf(m)
+                    ENDDO
+                 ENDDO
+              ELSE
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%surfhf_av(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%surfhf_av(m)
+                    ENDDO
+                 ENDDO
+              ENDIF
+ 
           CASE ( 'usm_wshf' )
 !--           array of sensible heat flux from surfaces
-!--           horizontal surfaces
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                   IF ( av == 0 )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = wshf_eb(isurf)
-                   ELSE
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = wshf_eb_av(isurf)
-                   ENDIF
-                 ENDIF
-              ENDDO
+              IF ( av == 0 )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%wshf_eb(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%wshf_eb(m)
+                    ENDDO
+                 ENDDO
+              ELSE
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%wshf_eb_av(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%wshf_eb_av(m)
+                    ENDDO
+                 ENDDO
+              ENDIF
+
 
           CASE ( 'usm_wghf' )
 !--           array of heat flux from ground (land, wall, roof)
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                   IF ( av == 0 )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = wghf_eb(isurf)
-                   ELSE
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = wghf_eb_av(isurf)
-                   ENDIF
-                 ENDIF
-              ENDDO
+              IF ( av == 0 )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%wghf_eb(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%wghf_eb(m)
+                    ENDDO
+                 ENDDO
+              ELSE
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%wghf_eb_av(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%wghf_eb_av(m)
+                    ENDDO
+                 ENDDO
+              ENDIF
 
           CASE ( 'usm_t_surf' )
 !--           surface temperature for surfaces
-              DO isurf = max(startenergy,dirstart(ids)), min(endenergy,dirend(ids))
-                 IF ( surfl(id,isurf) == ids )  THEN
-                   IF ( av == 0 )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = t_surf(isurf)
-                   ELSE
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = t_surf_av(isurf)
-                   ENDIF
-                 ENDIF
-              ENDDO
+              IF ( av == 0 )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = t_surf_h(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = t_surf_v(l)%t(m)
+                    ENDDO
+                 ENDDO
+              ELSE
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%t_surf_av(m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%t_surf_av(m)
+                    ENDDO
+                 ENDDO
+              ENDIF
               
           CASE ( 'usm_t_wall' )
 !--           wall temperature for  iwl layer of walls and land
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
-                   IF ( av == 0 )  THEN
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = t_wall(iwl,isurf)
-                   ELSE
-                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = t_wall_av(iwl,isurf)
-                   ENDIF
-                 ENDIF
-              ENDDO
+              IF ( av == 0 )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = t_wall_h(iwl,m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = t_wall_v(l)%t(iwl,m)
+                    ENDDO
+                 ENDDO
+              ELSE
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%t_wall_av(iwl,m)
+                 ENDDO
+                 DO  l = 0, 3
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%t_wall_av(iwl,m)
+                    ENDDO
+                 ENDDO
+              ENDIF
              
           CASE DEFAULT
@@ -2408,4 +2873,6 @@
 !--     fill out array local_pf which is subsequently treated by data_output_3d
         CALL exchange_horiz( temp_pf, nbgp )
+!
+!--  To Do: why reversed loop order
         DO j = nysg,nyng
             DO i = nxlg,nxrg
@@ -2589,5 +3056,5 @@
         IMPLICIT NONE
 
-        INTEGER(iwp) ::  k, l            !< running indices
+        INTEGER(iwp) ::  k, l, m            !< running indices
         
         CALL location_message( '    initialization of wall surface model', .TRUE. )
@@ -2596,26 +3063,55 @@
 !--     Temperature is defined at the center of the wall layers,
 !--     whereas gradients/fluxes are defined at the edges (_stag)
-        DO l = nzb_wall, nzt_wall
-           zwn(l) = zwn_default(l)
+        DO k = nzb_wall, nzt_wall
+           zwn(k) = zwn_default(k)
         ENDDO
-        
-!--     apply for all particular wall grids
-        DO l = startenergy, endenergy
-           zw(:,l) = zwn(:) * thickness_wall(l)
-           dz_wall(nzb_wall,l) = zw(nzb_wall,l)
+!        
+!--     apply for all particular surface grids. First for horizontal surfaces
+        DO  m = 1, surf_usm_h%ns
+           surf_usm_h%zw(:,m)             = zwn(:) *                           &
+                                            surf_usm_h%thickness_wall(m)
+           surf_usm_h%dz_wall(nzb_wall,m) = surf_usm_h%zw(nzb_wall,m)
            DO k = nzb_wall+1, nzt_wall
-               dz_wall(k,l) = zw(k,l) - zw(k-1,l)
+               surf_usm_h%dz_wall(k,m) = surf_usm_h%zw(k,m) -                  &
+                                         surf_usm_h%zw(k-1,m)
            ENDDO
            
-           dz_wall(nzt_wall+1,l) = dz_wall(nzt_wall,l)
+           surf_usm_h%dz_wall(nzt_wall+1,m) = surf_usm_h%dz_wall(nzt_wall,m)
 
            DO k = nzb_wall, nzt_wall-1
-               dz_wall_stag(k,l) = 0.5 * (dz_wall(k+1,l) + dz_wall(k,l))
+               surf_usm_h%dz_wall_stag(k,m) = 0.5 * (                          &
+                           surf_usm_h%dz_wall(k+1,m) + surf_usm_h%dz_wall(k,m) )
            ENDDO
-           dz_wall_stag(nzt_wall,l) = dz_wall(nzt_wall,l)
+           surf_usm_h%dz_wall_stag(nzt_wall,m) = surf_usm_h%dz_wall(nzt_wall,m)
         ENDDO
-        
-        ddz_wall      = 1.0_wp / dz_wall
-        ddz_wall_stag = 1.0_wp / dz_wall_stag
+        surf_usm_h%ddz_wall      = 1.0_wp / surf_usm_h%dz_wall
+        surf_usm_h%ddz_wall_stag = 1.0_wp / surf_usm_h%dz_wall_stag
+!        
+!--     For vertical surfaces
+        DO  l = 0, 3
+           DO  m = 1, surf_usm_v(l)%ns
+              surf_usm_v(l)%zw(:,m)             = zwn(:) *                     &
+                                                  surf_usm_v(l)%thickness_wall(m)
+              surf_usm_v(l)%dz_wall(nzb_wall,m) = surf_usm_v(l)%zw(nzb_wall,m)
+              DO k = nzb_wall+1, nzt_wall
+                  surf_usm_v(l)%dz_wall(k,m) = surf_usm_v(l)%zw(k,m) -         &
+                                               surf_usm_v(l)%zw(k-1,m)
+              ENDDO
+           
+              surf_usm_v(l)%dz_wall(nzt_wall+1,m) =                            &
+                                              surf_usm_v(l)%dz_wall(nzt_wall,m)
+
+              DO k = nzb_wall, nzt_wall-1
+                  surf_usm_v(l)%dz_wall_stag(k,m) = 0.5 * (                    &
+                                                surf_usm_v(l)%dz_wall(k+1,m) + &
+                                                surf_usm_v(l)%dz_wall(k,m) )
+              ENDDO
+              surf_usm_v(l)%dz_wall_stag(nzt_wall,m) =                         &
+                                              surf_usm_v(l)%dz_wall(nzt_wall,m)
+           ENDDO
+           surf_usm_v(l)%ddz_wall      = 1.0_wp / surf_usm_v(l)%dz_wall
+           surf_usm_v(l)%ddz_wall_stag = 1.0_wp / surf_usm_v(l)%dz_wall_stag
+        ENDDO      
+
         
         CALL location_message( '    wall structures filed out', .TRUE. )
@@ -2635,5 +3131,5 @@
         IMPLICIT NONE
 
-        INTEGER(iwp) ::  i, j, k, l            !< running indices
+        INTEGER(iwp) ::  i, j, k, l, m            !< running indices
         REAL(wp)     ::  c, d, tin, exn
         
@@ -2699,42 +3195,83 @@
         ELSE
        
-!--         Calculate initial surface temperature
+!--         Calculate initial surface temperature from pt of adjacent gridbox
             exn = ( surface_pressure / 1000.0_wp )**0.286_wp
 
-            DO l = startenergy, endenergy
-                k = surfl(iz,l)
-                j = surfl(iy,l)
-                i = surfl(ix,l)
-
-!--              Initial surface temperature set from pt of adjacent gridbox
-                t_surf(l) = pt(k,j,i) * exn
+!
+!--         At horizontal surfaces. Please note, t_surf_h is defined on a 
+!--         different data type, but with the same dimension.
+            DO  m = 1, surf_usm_h%ns
+               i = surf_usm_h%i(m)            
+               j = surf_usm_h%j(m)
+               k = surf_usm_h%k(m)
+
+               t_surf_h(m) = pt(k,j,i) * exn
             ENDDO
+!
+!--         At vertical surfaces.
+            DO  l = 0, 3
+               DO  m = 1, surf_usm_v(l)%ns
+                  i = surf_usm_v(l)%i(m)            
+                  j = surf_usm_v(l)%j(m)
+                  k = surf_usm_v(l)%k(m)
+
+                  t_surf_v(l)%t(m) = pt(k,j,i) * exn
+               ENDDO
+            ENDDO
+
       
 !--         initial values for t_wall
 !--         outer value is set to surface temperature
 !--         inner value is set to wall_inner_temperature
-!--         and profile is logaritmic (linear in nz)
-            DO l = startenergy, endenergy
-                IF ( isroof_surf(l) )  THEN
-                    tin = roof_inner_temperature
-                ELSE IF ( surf(id,l)==iroof )  THEN
-                    tin = soil_inner_temperature
-                ELSE
-                    tin = wall_inner_temperature
-                ENDIF
-                DO k = nzb_wall, nzt_wall+1
-                    c = REAL(k-nzb_wall,wp)/REAL(nzt_wall+1-nzb_wall,wp)
-                    t_wall(k,:) = (1.0_wp-c)*t_surf(:) + c*tin
-                ENDDO
+!--         and profile is logaritmic (linear in nz).
+!--         Horizontal surfaces
+            DO  m = 1, surf_usm_h%ns
+!
+!--            Roof
+               IF ( surf_usm_h%isroof_surf(m) )  THEN
+                   tin = roof_inner_temperature
+!
+!--            Normal land surface
+               ELSE 
+                   tin = soil_inner_temperature
+               ENDIF
+
+               DO k = nzb_wall, nzt_wall+1
+                   c = REAL( k - nzb_wall, wp ) /                              &
+                       REAL( nzt_wall + 1 - nzb_wall , wp )
+
+                   t_wall_h(k,m) = ( 1.0_wp - c ) * t_surf_h(m) + c * tin
+               ENDDO
             ENDDO
+!
+!--         Vertical surfaces
+            DO  l = 0, 3
+               DO  m = 1, surf_usm_v(l)%ns
+!
+!--               Inner wall
+                  tin = wall_inner_temperature
+
+                  DO k = nzb_wall, nzt_wall+1
+                     c = REAL( k - nzb_wall, wp ) /                            &
+                         REAL( nzt_wall + 1 - nzb_wall , wp )
+
+                     t_wall_v(l)%t(k,m) = ( 1.0_wp - c ) * t_surf_v(l)%t(m) +  &
+                                          c * tin
+                  ENDDO
+               ENDDO
+            ENDDO
+
         ENDIF
         
 !--    
-!--        Possibly DO user-defined actions (e.g. define heterogeneous wall surface)
+!--     Possibly DO user-defined actions (e.g. define heterogeneous wall surface)
         CALL user_init_urban_surface
 
 !--     initialize prognostic values for the first timestep
-        t_surf_p = t_surf
-        t_wall_p = t_wall
+        t_surf_h_p = t_surf_h
+        t_surf_v_p = t_surf_v
+
+        t_wall_h_p = t_wall_h
+        t_wall_v_p = t_wall_v
         
 !--     Adjust radiative fluxes for urban surface at model start
